net.sf.jasperreports.engine.fill

## Class JRFillChart

- java.lang.Object
- - net.sf.jasperreports.engine.fill.JRFillElement
  - - net.sf.jasperreports.engine.fill.JRFillChart

- All Implemented Interfaces:
    java.lang.Cloneable, DynamicPropertiesHolder, JRFillCloneable, JRAnchor, JRBoxContainer, JRChart, JRChild, JRCloneable, JRCommonElement, JRElement, JREvaluation, JRHyperlink, JRIdentifiable, JRPropertiesHolder, JRStyleContainer, JRStyleSetter, JRVisitable

      public class JRFillChart
      extends JRFillElement
      implements JRChart

  Version:
    $Id: JRFillChart.java 7088 2014-05-12 15:56:44Z lucianc $
  Author:
    Teodor Danciu (teodord@users.sourceforge.net), Some enhancements by Barry Klawans (bklawans@users.sourceforge.net)

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JRChartCustomizer` | `chartCustomizer`
    `protected ChartHyperlinkProvider` | `chartHyperlinkProvider`
    `protected byte` | `chartType`
    `protected java.lang.String` | `customizerClass`
    `protected JRFillChartDataset` | `dataset`
    `protected JRGroup` | `evaluationGroup`
    `protected JRLineBox` | `initLineBox`
    `protected org.jfree.chart.JFreeChart` | `jfreeChart`
    `protected JRFont` | `legendFont`
    `protected JRLineBox` | `lineBox`
    `protected JRChartPlot` | `plot`
    `protected Renderable` | `renderer`
    `protected java.lang.String` | `renderType`
    `protected JRFont` | `subtitleFont`
    `protected java.lang.String` | `themeName`
    `protected JRFont` | `titleFont`

    - ### Fields inherited from class net.sf.jasperreports.engine.fill.JRFillElement

      `band, conditionalStylesContainer, currentEvaluation, currentStyle, defaultStyleProvider, delayedEvaluationsMap, dynamicProperties, dynamicTransferProperties, elementGroup, expressionEvaluator, fillContainerContext, filler, initStyle, mergedProperties, originProvider, parent, printElementOriginator, printWhenGroupChanges, propertyExpressions, providerStyle, staticProperties, styleProviders, templates`

    - ### Fields inherited from interface net.sf.jasperreports.engine.JRChart

      `CHART_TYPE_AREA, CHART_TYPE_BAR, CHART_TYPE_BAR3D, CHART_TYPE_BUBBLE, CHART_TYPE_CANDLESTICK, CHART_TYPE_GANTT, CHART_TYPE_HIGHLOW, CHART_TYPE_LINE, CHART_TYPE_METER, CHART_TYPE_MULTI_AXIS, CHART_TYPE_PIE, CHART_TYPE_PIE3D, CHART_TYPE_SCATTER, CHART_TYPE_STACKEDAREA, CHART_TYPE_STACKEDBAR, CHART_TYPE_STACKEDBAR3D, CHART_TYPE_THERMOMETER, CHART_TYPE_TIMESERIES, CHART_TYPE_XYAREA, CHART_TYPE_XYBAR, CHART_TYPE_XYLINE, PROPERTY_CHART_RENDER_TYPE, PROPERTY_CHART_THEME, RENDER_TYPE_DRAW, RENDER_TYPE_IMAGE, RENDER_TYPE_SVG`

    - ### Fields inherited from interface net.sf.jasperreports.engine.JRAnchor

      `NO_BOOKMARK`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `JRFillChart(JRBaseFiller filler, JRChart chart, JRFillObjectFactory factory)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `collectExpressions(JRExpressionCollector collector)`
    `protected org.jfree.chart.plot.MeterInterval` | `convertInterval(JRMeterInterval interval, byte evaluation)` Converts a JasperReports meter interval to one that JFreeChart understands.
    `protected org.jfree.data.Range` | `convertRange(JRDataRange dataRange, byte evaluation)` Converts a JasperReport data range into one understood by JFreeChart.
    `protected void` | `copy(JRPrintImage printImage)`
    `protected ChartHyperlinkProvider` | `createChartHyperlinkProvider()`
    `JRFillCloneable` | `createClone(JRFillCloneFactory factory)` Creates a working clone of itself.
    `protected JRTemplateElement` | `createElementTemplate()`
    `protected void` | `createMultiAxisChart(byte evaluation)` Build and configure a multiple axis chart.
    `protected void` | `evaluate(byte evaluation)`
    `protected org.jfree.chart.JFreeChart` | `evaluateChart(byte evaluation)`
    `protected void` | `evaluateRenderer(byte evaluation)`
    `protected void` | `evaluateStyle(byte evaluation)`
    `protected JRPrintElement` | `fill()`
    `protected java.lang.String` | `getAnchorName()`
    `JRExpression` | `getAnchorNameExpression()` Returns an expression whose value represents the anchor name.
    `int` | `getBookmarkLevel()` Returns the level of the bookmark corresponding to the anchor.
    `protected org.jfree.chart.axis.AxisLocation` | `getChartAxisLocation(JRFillChartAxis chartAxis)`
    `byte` | `getChartType()` Gets the chart type.
    `java.lang.String` | `getCustomizerClass()` Gets a user specified chart customizer class name.
    `JRChartDataset` | `getDataset()` Gets the chart dataset.
    `java.awt.Color` | `getDefaultLineColor()`
    `JRGroup` | `getEvaluationGroup()` Gets the evaluation group for this text field.
    `EvaluationTimeEnum` | `getEvaluationTimeValue()` Gets the evaluation time for this text field.
    `protected java.lang.String` | `getHyperlinkAnchor()`
    `JRExpression` | `getHyperlinkAnchorExpression()` Returns the expression whose value represents the anchor.
    `protected java.lang.Integer` | `getHyperlinkPage()`
    `JRExpression` | `getHyperlinkPageExpression()` Returns an integer representing the page index of the link.
    `JRHyperlinkParameter[]` | `getHyperlinkParameters()` Returns the list of hyperlink parameters.
    `protected ChartHyperlinkProvider` | `getHyperlinkProvider()`
    `protected java.lang.String` | `getHyperlinkReference()`
    `JRExpression` | `getHyperlinkReferenceExpression()` Returns the expression whose value represents the hyperlink reference.
    `byte` | `getHyperlinkTarget()` Retrieves the hyperlink target for the element.
    `protected java.lang.String` | `getHyperlinkTooltip()`
    `JRExpression` | `getHyperlinkTooltipExpression()` Returns the expression which will generate the hyperlink tooltip.
    `byte` | `getHyperlinkType()` Deprecated. Replaced by `getHyperlinkTypeValue()`.
    `HyperlinkTypeEnum` | `getHyperlinkTypeValue()` Retrieves the hyperlink type for the element.
    `JRExpression` | `getHyperlinkWhenExpression()` Returns the expression that is evaluated in order to decide if the hyperlink should be displayed.
    `protected JRTemplateImage` | `getJRTemplateImage()`
    `java.awt.Color` | `getLegendBackgroundColor()` Returns the color to use as the background of the legend.
    `java.awt.Color` | `getLegendColor()` Returns the inherited color to use for text in the legend.
    `JRFont` | `getLegendFont()` Returns the font to use in the legend.
    `EdgeEnum` | `getLegendPositionValue()`
    `JRLineBox` | `getLineBox()`
    `java.lang.String` | `getLinkTarget()` Returns the hyperlink target name.
    `java.lang.String` | `getLinkType()` Returns the hyperlink type.
    `java.util.Locale` | `getLocale()`
    `ModeEnum` | `getModeValue()` Returns the element transparency mode.
    `java.awt.Color` | `getOwnLegendBackgroundColor()` Returns the color to use as the background of the legend.
    `java.awt.Color` | `getOwnLegendColor()` Returns the color to use for text in the legend.
    `java.awt.Color` | `getOwnSubtitleColor()`
    `java.awt.Color` | `getOwnTitleColor()`
    `JRChartPlot` | `getPlot()` Gets the chart plot.
    `protected Renderable` | `getRenderable()`
    `java.lang.String` | `getRenderType()`
    `java.lang.Boolean` | `getShowLegend()`
    `java.awt.Color` | `getSubtitleColor()`
    `JRExpression` | `getSubtitleExpression()` Gets the expression whose evaluation will form the subtitle.
    `JRFont` | `getSubtitleFont()`
    `java.lang.String` | `getTheme()`
    `java.util.TimeZone` | `getTimeZone()`
    `java.awt.Color` | `getTitleColor()`
    `JRExpression` | `getTitleExpression()` Gets the expression whose evaluation will form the title.
    `JRFont` | `getTitleFont()`
    `EdgeEnum` | `getTitlePositionValue()` Gets the title position relative to the chart.
    `protected boolean` | `prepare(int availableHeight, boolean isOverflow)`
    `protected void` | `resolveElement(JRPrintElement element, byte evaluation)` Resolves an element.
    `protected void` | `rewind()`
    `void` | `setBand(JRFillBand band)`
    `void` | `setDataset(JRFillChartDataset dataset)`
    `void` | `setLegendBackgroundColor(java.awt.Color legendBackgroundColor)` Sets the color to use for the background of the legend.
    `void` | `setLegendColor(java.awt.Color legendColor)` Sets the color to use for text in the legend.
    `void` | `setLegendPosition(EdgeEnum legendPosition)`
    `void` | `setRenderType(java.lang.String renderType)`
    `void` | `setShowLegend(java.lang.Boolean isShowLegend)`
    `void` | `setSubtitleColor(java.awt.Color subtitleColor)`
    `void` | `setTheme(java.lang.String theme)`
    `void` | `setTitleColor(java.awt.Color titleColor)`
    `void` | `setTitlePosition(EdgeEnum titlePosition)` Sets the title position relative to the chart.
    `void` | `visit(JRVisitor visitor)`

    - ### Methods inherited from class net.sf.jasperreports.engine.fill.JRFillElement

      `addDependantElement, addDynamicProperty, clone, clone, clone, collectDelayedEvaluations, collectDelayedEvaluations, collectDelayedEvaluations, collectStyleDelayedEvaluations, collectStyleProviderDelayedEvaluations, delayedEvaluate, delayedEvaluationUpdatesTemplate, evaluateExpression, evaluatePrintWhenExpression, evaluateProperties, getBackcolor, getBand, getConditionalStylesContainer, getDefaultStyleProvider, getDependantElements, getDynamicProperties, getElementGroup, getElementOrigin, getElementTemplate, getEvaluatedProperties, getField, getFiller, getForecolor, getGroupElements, getHeight, getInitStyle, getKey, getOwnBackcolor, getOwnForecolor, getOwnModeValue, getParent, getParentProperties, getPositionTypeValue, getPrintWhenExpression, getPrintWhenGroupChanges, getPropertiesMap, getPropertyExpressions, getRelativeY, getStretchHeight, getStretchTypeValue, getStyle, getStyleNameReference, getTemplate, getUUID, getVariable, getWidth, getX, getY, hasDynamicProperties, hasDynamicProperty, hasProperties, initDelayedEvaluationPrint, initDelayedEvaluations, initStyleProviders, isAlreadyPrinted, isAutoEvaluateNow, isDelayedStyleEvaluation, isEvaluateAuto, isEvaluateNow, isPrintInFirstWholeBand, isPrintRepeatedValues, isPrintWhenDetailOverflows, isPrintWhenExpressionNull, isPrintWhenTrue, isRemoveLineWhenBlank, isReprinted, isToPrint, isValueRepeating, moveDependantElements, performDelayedEvaluation, registerTemplate, reset, resolveElement, setAlreadyPrinted, setBackcolor, setConditionalStylesContainer, setCurrentEvaluation, setExpressionEvaluator, setForecolor, setHeight, setMode, setOriginProvider, setPositionType, setPrintInFirstWholeBand, setPrintRepeatedValues, setPrintWhenDetailOverflows, setPrintWhenExpressionNull, setPrintWhenTrue, setRelativeY, setRemoveLineWhenBlank, setReprinted, setShrinkable, setStretchHeight, setStretchType, setStyle, setStyleNameReference, setToPrint, setValueRepeating, setWidth, setX, setY, stretchElement, stretchElementToHeight, stretchHeightFinal, transferProperties, transferProperties`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.jasperreports.engine.JRElement

      `clone, getElementGroup, getKey, getPositionTypeValue, getPrintWhenExpression, getPrintWhenGroupChanges, getPropertyExpressions, getStretchTypeValue, getX, getY, isPrintInFirstWholeBand, isPrintRepeatedValues, isPrintWhenDetailOverflows, isRemoveLineWhenBlank, setPositionType, setPrintInFirstWholeBand, setPrintRepeatedValues, setPrintWhenDetailOverflows, setRemoveLineWhenBlank, setStretchType, setWidth, setX`

    - ### Methods inherited from interface net.sf.jasperreports.engine.JRChild

      `clone`

    - ### Methods inherited from interface net.sf.jasperreports.engine.JRCloneable

      `clone`

    - ### Methods inherited from interface net.sf.jasperreports.engine.JRCommonElement

      `getBackcolor, getForecolor, getHeight, getOwnBackcolor, getOwnForecolor, getOwnModeValue, getWidth, setBackcolor, setForecolor, setMode`

    - ### Methods inherited from interface net.sf.jasperreports.engine.JRStyleContainer

      `getDefaultStyleProvider, getStyle, getStyleNameReference`

    - ### Methods inherited from interface net.sf.jasperreports.engine.JRPropertiesHolder

      `getParentProperties, getPropertiesMap, hasProperties`

    - ### Methods inherited from interface net.sf.jasperreports.engine.JRIdentifiable

      `getUUID`

- - ### Field Detail

    - #### chartType

          protected byte chartType

    - #### titleFont

          protected JRFont titleFont

    - #### subtitleFont

          protected JRFont subtitleFont

    - #### legendFont

          protected JRFont legendFont

    - #### initLineBox

          protected final JRLineBox initLineBox

    - #### lineBox

          protected JRLineBox lineBox

    - #### evaluationGroup

          protected JRGroup evaluationGroup

    - #### dataset

          protected JRFillChartDataset dataset

    - #### plot

          protected JRChartPlot plot

    - #### renderer

          protected Renderable renderer

    - #### customizerClass

          protected java.lang.String customizerClass

    - #### chartCustomizer

          protected JRChartCustomizer chartCustomizer

    - #### renderType

          protected java.lang.String renderType

    - #### themeName

          protected java.lang.String themeName

    - #### jfreeChart

          protected org.jfree.chart.JFreeChart jfreeChart

    - #### chartHyperlinkProvider

          protected ChartHyperlinkProvider chartHyperlinkProvider

  - ### Constructor Detail

    - #### JRFillChart

          protected JRFillChart(JRBaseFiller filler,
                     JRChart chart,
                     JRFillObjectFactory factory)

  - ### Method Detail

    - #### setBand

          public void setBand(JRFillBand band)

      Overrides:
        `setBand` in class `JRFillElement`

    - #### evaluateStyle

          protected void evaluateStyle(byte evaluation)
                                throws JRException

      Overrides:
        `evaluateStyle` in class `JRFillElement`
      Throws:
        `JRException`

    - #### getModeValue

          public ModeEnum getModeValue()

      Description copied from interface: `JRCommonElement`
      Returns the element transparency mode. The default value depends on the type of the report element. Graphic elements like rectangles and lines are opaque by default, but the images are transparent. Both static texts and text fields are transparent by default, and so are the subreport elements.
      Specified by:
        `getModeValue` in interface `JRCommonElement`
      Overrides:
        `getModeValue` in class `JRFillElement`

    - #### getShowLegend

          public java.lang.Boolean getShowLegend()

      Specified by:
        `getShowLegend` in interface `JRChart`

    - #### setShowLegend

          public void setShowLegend(java.lang.Boolean isShowLegend)

      Specified by:
        `setShowLegend` in interface `JRChart`

    - #### getRenderType

          public java.lang.String getRenderType()

      Specified by:
        `getRenderType` in interface `JRChart`

    - #### setRenderType

          public void setRenderType(java.lang.String renderType)

      Specified by:
        `setRenderType` in interface `JRChart`

    - #### getTheme

          public java.lang.String getTheme()

      Specified by:
        `getTheme` in interface `JRChart`

    - #### setTheme

          public void setTheme(java.lang.String theme)

      Specified by:
        `setTheme` in interface `JRChart`

    - #### getEvaluationTimeValue

          public EvaluationTimeEnum getEvaluationTimeValue()

      Description copied from interface: `JREvaluation`
      Gets the evaluation time for this text field.
      Specified by:
        `getEvaluationTimeValue` in interface `JREvaluation`
      Overrides:
        `getEvaluationTimeValue` in class `JRFillElement`
      Returns:
        one of the evaluation time constants in `JRExpression`

    - #### getEvaluationGroup

          public JRGroup getEvaluationGroup()

      Description copied from interface: `JREvaluation`
      Gets the evaluation group for this text field. Used only when evaluation time is group.
      Specified by:
        `getEvaluationGroup` in interface `JREvaluation`
      See Also:
        `EvaluationTimeEnum.GROUP`

    - #### getLineBox

          public JRLineBox getLineBox()

      Specified by:
        `getLineBox` in interface `JRBoxContainer`

    - #### getTitleFont

          public JRFont getTitleFont()

      Specified by:
        `getTitleFont` in interface `JRChart`

    - #### getTitlePositionValue

          public EdgeEnum getTitlePositionValue()

      Description copied from interface: `JRChart`
      Gets the title position relative to the chart.
      Specified by:
        `getTitlePositionValue` in interface `JRChart`

    - #### setTitlePosition

          public void setTitlePosition(EdgeEnum titlePosition)

      Description copied from interface: `JRChart`
      Sets the title position relative to the chart.
      Specified by:
        `setTitlePosition` in interface `JRChart`

    - #### getTitleColor

          public java.awt.Color getTitleColor()

      Specified by:
        `getTitleColor` in interface `JRChart`

    - #### getOwnTitleColor

          public java.awt.Color getOwnTitleColor()

      Specified by:
        `getOwnTitleColor` in interface `JRChart`

    - #### setTitleColor

          public void setTitleColor(java.awt.Color titleColor)

      Specified by:
        `setTitleColor` in interface `JRChart`

    - #### getSubtitleFont

          public JRFont getSubtitleFont()

      Specified by:
        `getSubtitleFont` in interface `JRChart`

    - #### getOwnSubtitleColor

          public java.awt.Color getOwnSubtitleColor()

      Specified by:
        `getOwnSubtitleColor` in interface `JRChart`

    - #### getSubtitleColor

          public java.awt.Color getSubtitleColor()

      Specified by:
        `getSubtitleColor` in interface `JRChart`

    - #### setSubtitleColor

          public void setSubtitleColor(java.awt.Color subtitleColor)

      Specified by:
        `setSubtitleColor` in interface `JRChart`

    - #### getOwnLegendColor

          public java.awt.Color getOwnLegendColor()

      Returns the color to use for text in the legend.
      Specified by:
        `getOwnLegendColor` in interface `JRChart`
      Returns:
        the color to use for text in the legend

    - #### getLegendColor

          public java.awt.Color getLegendColor()

      Returns the inherited color to use for text in the legend.
      Specified by:
        `getLegendColor` in interface `JRChart`
      Returns:
        the color to use for text in the legend

    - #### setLegendColor

          public void setLegendColor(java.awt.Color legendColor)

      Sets the color to use for text in the legend.
      Specified by:
        `setLegendColor` in interface `JRChart`
      Parameters:
        `legendColor` - the color to use for text in the legend

    - #### getOwnLegendBackgroundColor

          public java.awt.Color getOwnLegendBackgroundColor()

      Returns the color to use as the background of the legend.
      Specified by:
        `getOwnLegendBackgroundColor` in interface `JRChart`
      Returns:
        the color to use as the background of the legend

    - #### getLegendBackgroundColor

          public java.awt.Color getLegendBackgroundColor()

      Returns the color to use as the background of the legend.
      Specified by:
        `getLegendBackgroundColor` in interface `JRChart`
      Returns:
        the color to use as the background of the legend

    - #### setLegendBackgroundColor

          public void setLegendBackgroundColor(java.awt.Color legendBackgroundColor)

      Sets the color to use for the background of the legend.
      Specified by:
        `setLegendBackgroundColor` in interface `JRChart`
      Parameters:
        `legendBackgroundColor` - the color to use for the background of the legend

    - #### getLegendFont

          public JRFont getLegendFont()

      Returns the font to use in the legend.
      Specified by:
        `getLegendFont` in interface `JRChart`
      Returns:
        the font to use in the legend

    - #### getLegendPositionValue

          public EdgeEnum getLegendPositionValue()

      Specified by:
        `getLegendPositionValue` in interface `JRChart`

    - #### setLegendPosition

          public void setLegendPosition(EdgeEnum legendPosition)

      Specified by:
        `setLegendPosition` in interface `JRChart`

    - #### getTitleExpression

          public JRExpression getTitleExpression()

      Description copied from interface: `JRChart`
      Gets the expression whose evaluation will form the title.
      Specified by:
        `getTitleExpression` in interface `JRChart`

    - #### getSubtitleExpression

          public JRExpression getSubtitleExpression()

      Description copied from interface: `JRChart`
      Gets the expression whose evaluation will form the subtitle.
      Specified by:
        `getSubtitleExpression` in interface `JRChart`

    - #### getHyperlinkType

          public byte getHyperlinkType()

      Deprecated. Replaced by `getHyperlinkTypeValue()`.
      Specified by:
        `getHyperlinkType` in interface `JRHyperlink`

    - #### getHyperlinkTypeValue

          public HyperlinkTypeEnum getHyperlinkTypeValue()

      Description copied from interface: `JRHyperlink`
      Retrieves the hyperlink type for the element.

      The actual hyperlink type is determined by `getLinkType()`. This method can is used to determine whether the hyperlink type is one of the built-in types or a custom type. When hyperlink is of custom type, `CUSTOM` is returned.

      Specified by:
        `getHyperlinkTypeValue` in interface `JRHyperlink`
      Returns:
        one of the hyperlink type constants
      See Also:
        `JRHyperlink.getLinkType()`

    - #### getHyperlinkTarget

          public byte getHyperlinkTarget()

      Description copied from interface: `JRHyperlink`
      Retrieves the hyperlink target for the element.

      The actual hyperlink target is determined by `getLinkTarget()`. This method can is used to determine whether the hyperlink target is one of the built-in target names or a custom one. When hyperlink has a custom target name, `HyperlinkTargetEnum.CUSTOM` is returned.

      Specified by:
        `getHyperlinkTarget` in interface `JRHyperlink`
      Returns:
        one of the hyperlink target constants
      See Also:
        `JRHyperlink.getLinkTarget()`

    - #### getAnchorNameExpression

          public JRExpression getAnchorNameExpression()

      Description copied from interface: `JRAnchor`
      Returns an expression whose value represents the anchor name.
      Specified by:
        `getAnchorNameExpression` in interface `JRAnchor`

    - #### getHyperlinkReferenceExpression

          public JRExpression getHyperlinkReferenceExpression()

      Description copied from interface: `JRHyperlink`
      Returns the expression whose value represents the hyperlink reference. It is only used when the hyperlink type is reference or anchor
      Specified by:
        `getHyperlinkReferenceExpression` in interface `JRHyperlink`

    - #### getHyperlinkWhenExpression

          public JRExpression getHyperlinkWhenExpression()

      Description copied from interface: `JRHyperlink`
      Returns the expression that is evaluated in order to decide if the hyperlink should be displayed. This expression always returns a boolean value.
      Specified by:
        `getHyperlinkWhenExpression` in interface `JRHyperlink`

    - #### getHyperlinkAnchorExpression

          public JRExpression getHyperlinkAnchorExpression()

      Description copied from interface: `JRHyperlink`
      Returns the expression whose value represents the anchor. It is only used when the hyperlink type is anchor.
      Specified by:
        `getHyperlinkAnchorExpression` in interface `JRHyperlink`

    - #### getHyperlinkPageExpression

          public JRExpression getHyperlinkPageExpression()

      Description copied from interface: `JRHyperlink`
      Returns an integer representing the page index of the link. It is only used when the hyperlink type is page. If the expression does not evaluate to an integer, an exception will be thrown.
      Specified by:
        `getHyperlinkPageExpression` in interface `JRHyperlink`

    - #### getLocale

          public java.util.Locale getLocale()

    - #### getTimeZone

          public java.util.TimeZone getTimeZone()

    - #### getDataset

          public JRChartDataset getDataset()

      Description copied from interface: `JRChart`
      Gets the chart dataset. Most chart types have different dataset structures, depending on the chart type.
      Specified by:
        `getDataset` in interface `JRChart`

    - #### setDataset

          public void setDataset(JRFillChartDataset dataset)

    - #### getPlot

          public JRChartPlot getPlot()

      Description copied from interface: `JRChart`
      Gets the chart plot. Plots are used to define various chart visual properties, such as colors and transparency.
      Specified by:
        `getPlot` in interface `JRChart`

    - #### getRenderable

          protected Renderable getRenderable()

    - #### getAnchorName

          protected java.lang.String getAnchorName()

    - #### getHyperlinkReference

          protected java.lang.String getHyperlinkReference()

    - #### getHyperlinkAnchor

          protected java.lang.String getHyperlinkAnchor()

    - #### getHyperlinkPage

          protected java.lang.Integer getHyperlinkPage()

    - #### getHyperlinkTooltip

          protected java.lang.String getHyperlinkTooltip()

    - #### getDefaultLineColor

          public java.awt.Color getDefaultLineColor()

      Specified by:
        `getDefaultLineColor` in interface `JRBoxContainer`

    - #### getJRTemplateImage

          protected JRTemplateImage getJRTemplateImage()

    - #### createElementTemplate

          protected JRTemplateElement createElementTemplate()

      Specified by:
        `createElementTemplate` in class `JRFillElement`

    - #### rewind

          protected void rewind()

      Specified by:
        `rewind` in class `JRFillElement`

    - #### evaluate

          protected void evaluate(byte evaluation)
                           throws JRException

      Specified by:
        `evaluate` in class `JRFillElement`
      Throws:
        `JRException`

    - #### evaluateRenderer

          protected void evaluateRenderer(byte evaluation)
                                   throws JRException

      Throws:
        `JRException`

    - #### getHyperlinkProvider

          protected ChartHyperlinkProvider getHyperlinkProvider()

    - #### evaluateChart

          protected org.jfree.chart.JFreeChart evaluateChart(byte evaluation)
                                                      throws JRException

      Throws:
        `JRException`

    - #### prepare

          protected boolean prepare(int availableHeight,
                        boolean isOverflow)

      Overrides:
        `prepare` in class `JRFillElement`

    - #### fill

          protected JRPrintElement fill()

      Specified by:
        `fill` in class `JRFillElement`

    - #### copy

          protected void copy(JRPrintImage printImage)

    - #### getChartType

          public byte getChartType()

      Description copied from interface: `JRChart`
      Gets the chart type. It must be one of the chart type constants in this class.
      Specified by:
        `getChartType` in interface `JRChart`

    - #### collectExpressions

          public void collectExpressions(JRExpressionCollector collector)

      Specified by:
        `collectExpressions` in interface `JRElement`

    - #### visit

          public void visit(JRVisitor visitor)

      Specified by:
        `visit` in interface `JRVisitable`

    - #### createChartHyperlinkProvider

          protected ChartHyperlinkProvider createChartHyperlinkProvider()

    - #### createMultiAxisChart

          protected void createMultiAxisChart(byte evaluation)
                                       throws JRException

      Build and configure a multiple axis chart. A multiple axis chart support more than one range axis. Multiple datasets using different ranges can be displayed as long as they share a common domain axis. Each dataset can be rendered differently, so one chart can contain (for example) two line charts, a bar chart and an area chart.
      Multiple axis charts are handled differently than the other chart types. They do not have a dataset, as each chart that is added to the multiple axis chart has its own dataset. For simplicity, each dataset is treated as its own chart, and in fact we reuse the design of all the chart types and let JFreeChart actually run them. Then we pull out the bits we need and add it to the common chart. All the plot and chart options on the nested charts is ignored, and all formatting is controlled by the plot attached to the multiAxisChart. The one exception is seriesColor, which can be used in a nested report to specify a color for a specific series in that report.
      Parameters:
        `evaluation` - current expression evaluation phase
      Throws:
        `JRException`

    - #### convertRange

          protected org.jfree.data.Range convertRange(JRDataRange dataRange,
                                          byte evaluation)
                                               throws JRException

      Converts a JasperReport data range into one understood by JFreeChart.
      Parameters:
        `dataRange` - the JasperReport version of the range
        `evaluation` - current expression evaluation phase
      Returns:
        the JFreeChart version of the range
      Throws:
        `JRException` - thrown when the low value of the range is greater than the high value

    - #### convertInterval

          protected org.jfree.chart.plot.MeterInterval convertInterval(JRMeterInterval interval,
                                                           byte evaluation)
                                                                throws JRException

      Converts a JasperReports meter interval to one that JFreeChart understands.
      Parameters:
        `interval` - the JasperReports definition of an interval
        `evaluation` - current evaluation time
      Returns:
        the JFreeChart version of the same interval
      Throws:
        `JRException` - thrown when the interval contains an invalid range

    - #### getChartAxisLocation

          protected org.jfree.chart.axis.AxisLocation getChartAxisLocation(JRFillChartAxis chartAxis)

    - #### resolveElement

          protected void resolveElement(JRPrintElement element,
                            byte evaluation)
                                 throws JRException

      Description copied from class: `JRFillElement`
      Resolves an element.
      Specified by:
        `resolveElement` in class `JRFillElement`
      Parameters:
        `element` - the element
        `evaluation` - the evaluation type
      Throws:
        `JRException`

    - #### getBookmarkLevel

          public int getBookmarkLevel()

      Description copied from interface: `JRAnchor`
      Returns the level of the bookmark corresponding to the anchor.
      Specified by:
        `getBookmarkLevel` in interface `JRAnchor`
      Returns:
        the level of the bookmark corresponding to the anchor (starting from 1) or `NO_BOOKMARK` if no bookmark should be created for this anchor

    - #### getCustomizerClass

          public java.lang.String getCustomizerClass()

      Description copied from interface: `JRChart`
      Gets a user specified chart customizer class name.
      Specified by:
        `getCustomizerClass` in interface `JRChart`
      See Also:
        `JRChartCustomizer`

    - #### createClone

          public JRFillCloneable createClone(JRFillCloneFactory factory)

      Description copied from interface: `JRFillCloneable`
      Creates a working clone of itself.
      Specified by:
        `createClone` in interface `JRFillCloneable`
      Parameters:
        `factory` - the clone factory to use while creating the clone
      Returns:
        a working clone of itself

    - #### getHyperlinkParameters

          public JRHyperlinkParameter[] getHyperlinkParameters()

      Description copied from interface: `JRHyperlink`
      Returns the list of hyperlink parameters.

      The parameters can be used by custom hyperlink types to generate dynamic links.

      Specified by:
        `getHyperlinkParameters` in interface `JRHyperlink`
      Returns:
        the list of hyperlink parameters

    - #### getLinkType

          public java.lang.String getLinkType()

      Description copied from interface: `JRHyperlink`
      Returns the hyperlink type.

      The type can be one of the built-in types (Reference, LocalAnchor, LocalPage, RemoteAnchor, RemotePage), or can be an arbitrary type.

      Specified by:
        `getLinkType` in interface `JRHyperlink`
      Returns:
        the hyperlink type

    - #### getLinkTarget

          public java.lang.String getLinkTarget()

      Description copied from interface: `JRHyperlink`
      Returns the hyperlink target name.

      The type can be one of the built-in names (Self, Blank, Top, Parent), or can be an arbitrary name.

      Specified by:
        `getLinkTarget` in interface `JRHyperlink`
      Returns:
        the hyperlink target name

    - #### getHyperlinkTooltipExpression

          public JRExpression getHyperlinkTooltipExpression()

      Description copied from interface: `JRHyperlink`
      Returns the expression which will generate the hyperlink tooltip.
      Specified by:
        `getHyperlinkTooltipExpression` in interface `JRHyperlink`
      Returns:
        the expression which will generate the hyperlink tooltip

© 2001-2010 Jaspersoft Corporation www.jaspersoft.com